=== tools/bugpoint-passes/CMakeLists.txt ===
add_llvm_loadable_module( BugpointPasses
  TestPasses.cpp
  )
