=== debian/changelog ===
llvm-2.8 (2.8-7build4ubuntu2) quantal; urgency=low

  * Don't assume that debian/patches/ == quilt. Use package patch system.

 -- Ben Collins <bcollins@ubuntu.com>  Fri, 06 Jul 2012 00:39:10 -0400

llvm-2.8 (2.8-7build4ubuntu1) quantal; urgency=low

  * include-headers-for-lseek64.patch: Fixes build failures

 -- Ben Collins <bcollins@ubuntu.com>  Fri, 06 Jul 2012 00:04:56 -0400

llvm-2.8 (2.8-7build4) quantal; urgency=low

  * Rebuild with the latest armel toolchain.

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 27 Apr 2012 09:06:01 -0600

llvm-2.8 (2.8-7build3) precise; urgency=low

  * Rebuild with ocamlopt on armhf.

 -- Colin Watson <cjwatson@ubuntu.com>  Tue, 24 Jan 2012 00:42:51 +0000

llvm-2.8 (2.8-7build2) precise; urgency=low

  * Rebuild for OCaml 3.12.1.

 -- Colin Watson <cjwatson@ubuntu.com>  Fri, 18 Nov 2011 20:54:33 +0000

llvm-2.8 (2.8-7build1) oneiric; urgency=low

  * Rebuild to pick up armel ocaml fixes.

 -- Adam Conrad <adconrad@ubuntu.com>  Fri, 19 Aug 2011 13:25:21 -0600

llvm-2.8 (2.8-7) unstable; urgency=low

  * Bad usage of ifeq was failing llvm build under kfreebsd-amd64 	

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 27 Jun 2011 10:19:25 +0200

llvm-2.8 (2.8-6) unstable; urgency=low

  * rules.d/build.mk: Enable the serial execution of the testsuite. It was
    breaking the build under kfreebsd. Thanks to Christoph Egger for finding
    this (Closes: #621902)
  * debhelper.in/libllvm2.8.install, debhelper.in/llvm-dev.links,
    packages.d/llvm.mk: Also build LLVM gold plugin for clang -O4 option
    (Closes: #631178)
  * control.in/clang, debhelper.in/clang.install, debhelper.in/clang.links,
    debhelper.in/llvm-gcc-4.2.links, debhelper.in/llvm-gcc-4.2.install,
    packages.d/tools.mk, debian/rules:
    Remove deprecated stuff.

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 26 Jun 2011 19:56:14 +0200

llvm-2.8 (2.8-5) unstable; urgency=low

  * debian/patches/kfreebsd.diff, 0034-kfreebsd.patch:
    Rename the kfreebsd patch to make sure it is taken in account.
  * debian/control: libllvm-ocaml-2.8-dev renamed to libllvm-2.8-ocaml-dev

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 19 May 2011 10:04:54 +0200

llvm-2.8 (2.8-4) unstable; urgency=low

  * Fix FTBFS under kfreebsd
  * Rename META.llvm-2.8 to META.llvm-2_8 to make sure ocamlfind finds it
    (Closes: #623628, #625818)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 17 May 2011 15:20:50 +0200

llvm-2.8 (2.8-3) unstable; urgency=low

  * debian/debhelper.in/llvm-runtime.prerm,
    debian/debhelper.in/llvm-runtime.postinst: uses the exact version of llvm
    to call binfmt (Closes: #622672)
  * debhelper.in/llvm-dev.install, Rename vim files (llvm.vim => llvm-2.8.vim
    & tablegen.vim => tablegen-2.8.vim) and manage it through llvm-dev
    (from llvm-defaults)
  * rules.d/vars.mk, debian/packages.d/llvm.mk: Always build shared libraries
    (it was causing llvm-2.8 under kfreebsd-i386 to be 20 times bigger than
    under other archs and libllvm2.8 not available)
  * debian/control, debian/control.in/llvm: update of the description (it was
    refering to gcc 4.0.1)
  * control.in/llvm-gcc-4.2, control.in/llvm-snapshot, 
    packages.d/llvm-gcc-4.2.mk, packages.d/llvm-snapshot.mk: removed
  * Pierre Habouzit <madcoder@debian.org> removed from uploaders.

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 12 Apr 2011 15:57:37 +0200

llvm-2.8 (2.8-2) unstable; urgency=low

  * Upload in unstable
  * Update of the tags Vcs-Svn, Vcs-Browser and uploader
  * watch file added
  * Standards-Version updated to version 3.9.2

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 14 Feb 2011 23:48:42 +0100

llvm-2.8 (2.8-1) experimental; urgency=low

  * Sync from Ubuntu
  * New upstream release (Closes: #601074)
     * llc no longer segfault when dealing with invalid bitcode 
       (Closes: #588708)
  * Add myself to the uploaders.
  * Install vim files at the right place (Closes: #605855)
  * Manpage renamed (Closes: #592342)
  * Update llvm.binfmt to be able to execute LLVM bitcode directly
    (Closes: #610585)
  * Some manpages were badly named (Closes: #592342)
  * Switch to dpkg-source 3.0 (quilt) format

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 14 Feb 2011 00:45:50 +0100

llvm-2.8 (2.8-0ubuntu1) maverick; urgency=low

  * LLVM-2.8 final release. LP: #632727.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 06 Oct 2010 13:34:22 +0200

llvm-2.8 (2.8~20100921-0ubuntu2) maverick; urgency=low

  * llvm-2.8-dev: Install versioned 2.8 vim files.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Sep 2010 19:21:25 +0200

llvm-2.8 (2.8~20100921-0ubuntu1) maverick; urgency=low

  * New upstream snapshot, taken from the 2.8 branch.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 21 Sep 2010 14:03:34 +0200

llvm-2.8 (2.8~20100911-0ubuntu1) maverick; urgency=low

  * New upstream snapshot, taken from the 2.8 branch.
    - ARM regression fixes.
    - They call it rc now instead of svn. Let's believe it despite
      the regressions on powerpc.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 13 Sep 2010 00:44:44 +0200

llvm-2.8 (2.8~20100907-0ubuntu1) maverick; urgency=low

  * New upstream snapshot, taken from the 2.8 branch.
  * Provide a symlink /usr/lib/llvm-2.8svn -> llvm-2.8.
  * Merge build fixes from clang and llvm-gcc-4.2.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Sep 2010 17:51:17 +0200

llvm-2.8 (2.8~20100906-0ubuntu2) maverick; urgency=low

  * llvm-2.8: Don't include lli-2.8, already included in llvm-2.8-runtime.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Sep 2010 12:09:36 +0200

llvm-2.8 (2.8~20100906-0ubuntu1) maverick; urgency=low

  * New upstream snapshot, taken from the 2.8 branch.
  * Do not provide unversioned names for binaries. LP: #625644, #626108.
  * Fix order of debhelper calls. LP: #625437.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 06 Sep 2010 16:05:03 +0200

llvm-2.8 (2.8~20100826-0ubuntu1) maverick; urgency=low

  * New upstream snapshot.
  * Merge changes from 2.7-5.


